Index: LMDZ6/branches/Amaury_dev/libf/phylmd/phys_local_var_mod.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/phys_local_var_mod.F90	(revision 5095)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/phys_local_var_mod.F90	(revision 5098)
@@ -2,129 +2,130 @@
 ! $Id$
 !
-      MODULE phys_local_var_mod
-! Variables locales pour effectuer les appels en serie
-!======================================================================
-!
-!
-!======================================================================
-! Declaration des variables
-
-      REAL, SAVE, ALLOCATABLE :: t_seri(:,:), q_seri(:,:)
-      !$OMP THREADPRIVATE(t_seri, q_seri)
-      REAL, SAVE, ALLOCATABLE :: ql_seri(:,:),qs_seri(:,:)
-      !$OMP THREADPRIVATE(ql_seri,qs_seri)
-! SN 15/07/2024 ISO 4D
-      REAL, SAVE, ALLOCATABLE :: qx_seri(:,:,:)
-      !$OMP THREADPRIVATE(qx_seri)
-! SN
-      REAL, SAVE, ALLOCATABLE :: qbs_seri(:,:)
-      !$OMP THREADPRIVATE(qbs_seri)
-      REAL, SAVE, ALLOCATABLE :: u_seri(:,:), v_seri(:,:)
-      !$OMP THREADPRIVATE(u_seri, v_seri)
-      REAL, SAVE, ALLOCATABLE :: rneb_seri(:,:)
-      !$OMP THREADPRIVATE(rneb_seri)
-      REAL, SAVE, ALLOCATABLE :: d_rneb_dyn(:,:)
-      !$OMP THREADPRIVATE(d_rneb_dyn)
-      REAL, SAVE, ALLOCATABLE :: l_mixmin(:,:,:),l_mix(:,:,:),wprime(:,:,:)
-      !$OMP THREADPRIVATE(l_mixmin, l_mix, wprime)
-      REAL, SAVE, ALLOCATABLE :: pbl_eps(:,:,:)
-      !$OMP THREADPRIVATE(pbl_eps)
-      REAL, SAVE, ALLOCATABLE :: tke_shear(:,:,:), tke_buoy(:,:,:), tke_trans(:,:,:)
-      !$OMP THREADPRIVATE(tke_shear,tke_buoy,tke_trans)
-      REAL, SAVE, ALLOCATABLE :: tr_seri(:,:,:)
-      !$OMP THREADPRIVATE(tr_seri)
-      REAL, SAVE, ALLOCATABLE :: rhcl(:,:)
-      !$OMP THREADPRIVATE(rhcl)
-      REAL, SAVE, ALLOCATABLE :: d_t_dyn(:,:), d_q_dyn(:,:)
-      !$OMP THREADPRIVATE(d_t_dyn, d_q_dyn)
-      REAL, SAVE, ALLOCATABLE :: d_ql_dyn(:,:), d_qs_dyn(:,:), d_qbs_dyn(:,:)
-      !$OMP THREADPRIVATE(d_ql_dyn, d_qs_dyn, d_qbs_dyn)
-      REAL, SAVE, ALLOCATABLE :: d_q_dyn2d(:), d_ql_dyn2d(:), d_qs_dyn2d(:), d_qbs_dyn2d(:)
-      !$OMP THREADPRIVATE(d_q_dyn2d, d_ql_dyn2d, d_qs_dyn2d, d_qbs_dyn2d)
-      REAL, SAVE, ALLOCATABLE :: d_u_dyn(:,:), d_v_dyn(:,:)
-      !$OMP THREADPRIVATE(d_u_dyn, d_v_dyn)
-      REAL, SAVE, ALLOCATABLE :: d_tr_dyn(:,:,:)
-      !$OMP THREADPRIVATE(d_tr_dyn)
-      REAL, SAVE, ALLOCATABLE :: d_t_con(:,:),d_q_con(:,:),d_q_con_zmasse(:,:)
-      !$OMP THREADPRIVATE(d_t_con,d_q_con,d_q_con_zmasse)
-      REAL, SAVE, ALLOCATABLE :: d_u_con(:,:),d_v_con(:,:)
-      !$OMP THREADPRIVATE(d_u_con,d_v_con)
-      REAL, SAVE, ALLOCATABLE :: d_t_wake(:,:),d_q_wake(:,:)
-      !$OMP THREADPRIVATE( d_t_wake,d_q_wake)
-      REAL, SAVE, ALLOCATABLE :: d_t_lsc(:,:),d_q_lsc(:,:),d_ql_lsc(:,:),d_qi_lsc(:,:)
-      !$OMP THREADPRIVATE(d_t_lsc,d_q_lsc,d_ql_lsc,d_qi_lsc)
-      REAL, SAVE, ALLOCATABLE :: d_t_lwr(:,:),d_t_lw0(:,:),d_t_swr(:,:),d_t_sw0(:,:)
-      !$OMP THREADPRIVATE(d_t_lwr,d_t_lw0,d_t_swr,d_t_sw0)
-      REAL, SAVE, ALLOCATABLE :: d_t_ajsb(:,:), d_q_ajsb(:,:)
-      !$OMP THREADPRIVATE(d_t_ajsb, d_q_ajsb)
-      REAL, SAVE, ALLOCATABLE :: d_t_ajs(:,:), d_q_ajs(:,:)
-      !$OMP THREADPRIVATE(d_t_ajs, d_q_ajs)
-      REAL, SAVE, ALLOCATABLE :: d_u_ajs(:,:), d_v_ajs(:,:)
-      !$OMP THREADPRIVATE(d_u_ajs, d_v_ajs)
-!nrlmd<
-      REAL, SAVE, ALLOCATABLE :: d_t_ajs_w(:,:), d_q_ajs_w(:,:)
-      !$OMP THREADPRIVATE(d_t_ajs_w, d_q_ajs_w)
-      REAL, SAVE, ALLOCATABLE :: d_t_ajs_x(:,:), d_q_ajs_x(:,:)
-      !$OMP THREADPRIVATE(d_t_ajs_x, d_q_ajs_x)
-!>nrlmd
-      REAL, SAVE, ALLOCATABLE :: d_t_eva(:,:),d_q_eva(:,:),d_ql_eva(:,:),d_qi_eva(:,:)
-      !$OMP THREADPRIVATE(d_t_eva,d_q_eva,d_ql_eva,d_qi_eva)
-! SN 15/07/2024 ISO 4D
-      REAL, SAVE, ALLOCATABLE :: d_qx_eva(:,:,:)
-      !$OMP THREADPRIVATE(d_qx_eva)
-! SN
-      REAL, SAVE, ALLOCATABLE :: d_t_lscst(:,:),d_q_lscst(:,:)
-      !$OMP THREADPRIVATE(d_t_lscst,d_q_lscst)
-      REAL, SAVE, ALLOCATABLE :: d_t_lscth(:,:),d_q_lscth(:,:)
-      !$OMP THREADPRIVATE(d_t_lscth,d_q_lscth)
-      REAL, SAVE, ALLOCATABLE :: plul_th(:),plul_st(:)
-      !$OMP THREADPRIVATE(plul_th,plul_st)
-!tendances dues a oro et lif
-      REAL, SAVE, ALLOCATABLE :: d_t_oli(:,:)
-      !$OMP THREADPRIVATE(d_t_oli)
-      REAL, SAVE, ALLOCATABLE :: d_u_oli(:,:), d_v_oli(:,:)
-      !$OMP THREADPRIVATE(d_u_oli, d_v_oli)
-      REAL, SAVE, ALLOCATABLE :: d_t_vdf(:,:), d_q_vdf(:,:), d_qbs_vdf(:,:), d_t_diss(:,:)
-      !$OMP THREADPRIVATE( d_t_vdf, d_q_vdf, d_qbs_vdf, d_t_diss)
-      REAL, SAVE, ALLOCATABLE :: d_u_vdf(:,:), d_v_vdf(:,:)
-      !$OMP THREADPRIVATE(d_u_vdf, d_v_vdf)
-!nrlmd+jyg<
-      REAL, SAVE, ALLOCATABLE :: d_t_vdf_w(:,:), d_q_vdf_w(:,:)
-      !$OMP THREADPRIVATE( d_t_vdf_w, d_q_vdf_w)
-      REAL, SAVE, ALLOCATABLE :: d_t_vdf_x(:,:), d_q_vdf_x(:,:)
-      !$OMP THREADPRIVATE( d_t_vdf_x, d_q_vdf_x)
-      REAL, SAVE, ALLOCATABLE :: d_t_bsss(:,:), d_q_bsss(:,:), d_qbs_bsss(:,:)
-      !$OMP THREADPRIVATE( d_t_bsss,d_q_bsss, d_qbs_bsss)
-!>nrlmd+jyg
-      REAL, SAVE, ALLOCATABLE :: d_t_oro(:,:)
-      !$OMP THREADPRIVATE(d_t_oro)
-      REAL, SAVE, ALLOCATABLE :: d_u_oro(:,:), d_v_oro(:,:)
-      !$OMP THREADPRIVATE(d_u_oro, d_v_oro)
-      REAL, SAVE, ALLOCATABLE :: d_t_oro_gw(:,:)
-      !$OMP THREADPRIVATE(d_t_oro_gw)
-      REAL, SAVE, ALLOCATABLE :: d_u_oro_gw(:,:), d_v_oro_gw(:,:)
-      !$OMP THREADPRIVATE(d_u_oro_gw, d_v_oro_gw)
-      REAL, SAVE, ALLOCATABLE :: d_t_lif(:,:)
-      !$OMP THREADPRIVATE(d_t_lif)
-      REAL, SAVE, ALLOCATABLE :: d_u_lif(:,:), d_v_lif(:,:)
-      !$OMP THREADPRIVATE(d_u_lif, d_v_lif)
-! Tendances Ondes de G non oro (runs strato).
-      REAL, SAVE, ALLOCATABLE :: du_gwd_hines(:,:)
-      !$OMP THREADPRIVATE(du_gwd_hines)
-      REAL, SAVE, ALLOCATABLE :: dv_gwd_hines(:,:)
-      !$OMP THREADPRIVATE(dv_gwd_hines)
-      REAL, SAVE, ALLOCATABLE :: dv_gwd_rando(:,:)
-      !$OMP THREADPRIVATE(dv_gwd_rando)
-      REAL, SAVE, ALLOCATABLE :: dv_gwd_front(:,:)
-      !$OMP THREADPRIVATE(dv_gwd_front)
-      REAL, SAVE, ALLOCATABLE :: east_gwstress(:,:)
-      !$OMP THREADPRIVATE(east_gwstress)
-      REAL, SAVE, ALLOCATABLE :: west_gwstress(:,:)
-      !$OMP THREADPRIVATE(west_gwstress)
-      REAL, SAVE, ALLOCATABLE :: d_t_hin(:,:)
-      !$OMP THREADPRIVATE(d_t_hin)
-! tendance due a l'oxydation du methane
-      REAL, SAVE, ALLOCATABLE :: d_q_ch4(:,:)
-      !$OMP THREADPRIVATE(d_q_ch4)
+MODULE phys_local_var_mod
+  USE lmdz_cppkeys_wrapper, ONLY : CPPKEY_STRATAER
+  ! Variables locales pour effectuer les appels en serie
+  !======================================================================
+  !
+  !
+  !======================================================================
+  ! Declaration des variables
+
+  REAL, SAVE, ALLOCATABLE :: t_seri(:, :), q_seri(:, :)
+  !$OMP THREADPRIVATE(t_seri, q_seri)
+  REAL, SAVE, ALLOCATABLE :: ql_seri(:, :), qs_seri(:, :)
+  !$OMP THREADPRIVATE(ql_seri,qs_seri)
+  ! SN 15/07/2024 ISO 4D
+  REAL, SAVE, ALLOCATABLE :: qx_seri(:, :, :)
+  !$OMP THREADPRIVATE(qx_seri)
+  ! SN
+  REAL, SAVE, ALLOCATABLE :: qbs_seri(:, :)
+  !$OMP THREADPRIVATE(qbs_seri)
+  REAL, SAVE, ALLOCATABLE :: u_seri(:, :), v_seri(:, :)
+  !$OMP THREADPRIVATE(u_seri, v_seri)
+  REAL, SAVE, ALLOCATABLE :: rneb_seri(:, :)
+  !$OMP THREADPRIVATE(rneb_seri)
+  REAL, SAVE, ALLOCATABLE :: d_rneb_dyn(:, :)
+  !$OMP THREADPRIVATE(d_rneb_dyn)
+  REAL, SAVE, ALLOCATABLE :: l_mixmin(:, :, :), l_mix(:, :, :), wprime(:, :, :)
+  !$OMP THREADPRIVATE(l_mixmin, l_mix, wprime)
+  REAL, SAVE, ALLOCATABLE :: pbl_eps(:, :, :)
+  !$OMP THREADPRIVATE(pbl_eps)
+  REAL, SAVE, ALLOCATABLE :: tke_shear(:, :, :), tke_buoy(:, :, :), tke_trans(:, :, :)
+  !$OMP THREADPRIVATE(tke_shear,tke_buoy,tke_trans)
+  REAL, SAVE, ALLOCATABLE :: tr_seri(:, :, :)
+  !$OMP THREADPRIVATE(tr_seri)
+  REAL, SAVE, ALLOCATABLE :: rhcl(:, :)
+  !$OMP THREADPRIVATE(rhcl)
+  REAL, SAVE, ALLOCATABLE :: d_t_dyn(:, :), d_q_dyn(:, :)
+  !$OMP THREADPRIVATE(d_t_dyn, d_q_dyn)
+  REAL, SAVE, ALLOCATABLE :: d_ql_dyn(:, :), d_qs_dyn(:, :), d_qbs_dyn(:, :)
+  !$OMP THREADPRIVATE(d_ql_dyn, d_qs_dyn, d_qbs_dyn)
+  REAL, SAVE, ALLOCATABLE :: d_q_dyn2d(:), d_ql_dyn2d(:), d_qs_dyn2d(:), d_qbs_dyn2d(:)
+  !$OMP THREADPRIVATE(d_q_dyn2d, d_ql_dyn2d, d_qs_dyn2d, d_qbs_dyn2d)
+  REAL, SAVE, ALLOCATABLE :: d_u_dyn(:, :), d_v_dyn(:, :)
+  !$OMP THREADPRIVATE(d_u_dyn, d_v_dyn)
+  REAL, SAVE, ALLOCATABLE :: d_tr_dyn(:, :, :)
+  !$OMP THREADPRIVATE(d_tr_dyn)
+  REAL, SAVE, ALLOCATABLE :: d_t_con(:, :), d_q_con(:, :), d_q_con_zmasse(:, :)
+  !$OMP THREADPRIVATE(d_t_con,d_q_con,d_q_con_zmasse)
+  REAL, SAVE, ALLOCATABLE :: d_u_con(:, :), d_v_con(:, :)
+  !$OMP THREADPRIVATE(d_u_con,d_v_con)
+  REAL, SAVE, ALLOCATABLE :: d_t_wake(:, :), d_q_wake(:, :)
+  !$OMP THREADPRIVATE( d_t_wake,d_q_wake)
+  REAL, SAVE, ALLOCATABLE :: d_t_lsc(:, :), d_q_lsc(:, :), d_ql_lsc(:, :), d_qi_lsc(:, :)
+  !$OMP THREADPRIVATE(d_t_lsc,d_q_lsc,d_ql_lsc,d_qi_lsc)
+  REAL, SAVE, ALLOCATABLE :: d_t_lwr(:, :), d_t_lw0(:, :), d_t_swr(:, :), d_t_sw0(:, :)
+  !$OMP THREADPRIVATE(d_t_lwr,d_t_lw0,d_t_swr,d_t_sw0)
+  REAL, SAVE, ALLOCATABLE :: d_t_ajsb(:, :), d_q_ajsb(:, :)
+  !$OMP THREADPRIVATE(d_t_ajsb, d_q_ajsb)
+  REAL, SAVE, ALLOCATABLE :: d_t_ajs(:, :), d_q_ajs(:, :)
+  !$OMP THREADPRIVATE(d_t_ajs, d_q_ajs)
+  REAL, SAVE, ALLOCATABLE :: d_u_ajs(:, :), d_v_ajs(:, :)
+  !$OMP THREADPRIVATE(d_u_ajs, d_v_ajs)
+  !nrlmd<
+  REAL, SAVE, ALLOCATABLE :: d_t_ajs_w(:, :), d_q_ajs_w(:, :)
+  !$OMP THREADPRIVATE(d_t_ajs_w, d_q_ajs_w)
+  REAL, SAVE, ALLOCATABLE :: d_t_ajs_x(:, :), d_q_ajs_x(:, :)
+  !$OMP THREADPRIVATE(d_t_ajs_x, d_q_ajs_x)
+  !>nrlmd
+  REAL, SAVE, ALLOCATABLE :: d_t_eva(:, :), d_q_eva(:, :), d_ql_eva(:, :), d_qi_eva(:, :)
+  !$OMP THREADPRIVATE(d_t_eva,d_q_eva,d_ql_eva,d_qi_eva)
+  ! SN 15/07/2024 ISO 4D
+  REAL, SAVE, ALLOCATABLE :: d_qx_eva(:, :, :)
+  !$OMP THREADPRIVATE(d_qx_eva)
+  ! SN
+  REAL, SAVE, ALLOCATABLE :: d_t_lscst(:, :), d_q_lscst(:, :)
+  !$OMP THREADPRIVATE(d_t_lscst,d_q_lscst)
+  REAL, SAVE, ALLOCATABLE :: d_t_lscth(:, :), d_q_lscth(:, :)
+  !$OMP THREADPRIVATE(d_t_lscth,d_q_lscth)
+  REAL, SAVE, ALLOCATABLE :: plul_th(:), plul_st(:)
+  !$OMP THREADPRIVATE(plul_th,plul_st)
+  !tendances dues a oro et lif
+  REAL, SAVE, ALLOCATABLE :: d_t_oli(:, :)
+  !$OMP THREADPRIVATE(d_t_oli)
+  REAL, SAVE, ALLOCATABLE :: d_u_oli(:, :), d_v_oli(:, :)
+  !$OMP THREADPRIVATE(d_u_oli, d_v_oli)
+  REAL, SAVE, ALLOCATABLE :: d_t_vdf(:, :), d_q_vdf(:, :), d_qbs_vdf(:, :), d_t_diss(:, :)
+  !$OMP THREADPRIVATE( d_t_vdf, d_q_vdf, d_qbs_vdf, d_t_diss)
+  REAL, SAVE, ALLOCATABLE :: d_u_vdf(:, :), d_v_vdf(:, :)
+  !$OMP THREADPRIVATE(d_u_vdf, d_v_vdf)
+  !nrlmd+jyg<
+  REAL, SAVE, ALLOCATABLE :: d_t_vdf_w(:, :), d_q_vdf_w(:, :)
+  !$OMP THREADPRIVATE( d_t_vdf_w, d_q_vdf_w)
+  REAL, SAVE, ALLOCATABLE :: d_t_vdf_x(:, :), d_q_vdf_x(:, :)
+  !$OMP THREADPRIVATE( d_t_vdf_x, d_q_vdf_x)
+  REAL, SAVE, ALLOCATABLE :: d_t_bsss(:, :), d_q_bsss(:, :), d_qbs_bsss(:, :)
+  !$OMP THREADPRIVATE( d_t_bsss,d_q_bsss, d_qbs_bsss)
+  !>nrlmd+jyg
+  REAL, SAVE, ALLOCATABLE :: d_t_oro(:, :)
+  !$OMP THREADPRIVATE(d_t_oro)
+  REAL, SAVE, ALLOCATABLE :: d_u_oro(:, :), d_v_oro(:, :)
+  !$OMP THREADPRIVATE(d_u_oro, d_v_oro)
+  REAL, SAVE, ALLOCATABLE :: d_t_oro_gw(:, :)
+  !$OMP THREADPRIVATE(d_t_oro_gw)
+  REAL, SAVE, ALLOCATABLE :: d_u_oro_gw(:, :), d_v_oro_gw(:, :)
+  !$OMP THREADPRIVATE(d_u_oro_gw, d_v_oro_gw)
+  REAL, SAVE, ALLOCATABLE :: d_t_lif(:, :)
+  !$OMP THREADPRIVATE(d_t_lif)
+  REAL, SAVE, ALLOCATABLE :: d_u_lif(:, :), d_v_lif(:, :)
+  !$OMP THREADPRIVATE(d_u_lif, d_v_lif)
+  ! Tendances Ondes de G non oro (runs strato).
+  REAL, SAVE, ALLOCATABLE :: du_gwd_hines(:, :)
+  !$OMP THREADPRIVATE(du_gwd_hines)
+  REAL, SAVE, ALLOCATABLE :: dv_gwd_hines(:, :)
+  !$OMP THREADPRIVATE(dv_gwd_hines)
+  REAL, SAVE, ALLOCATABLE :: dv_gwd_rando(:, :)
+  !$OMP THREADPRIVATE(dv_gwd_rando)
+  REAL, SAVE, ALLOCATABLE :: dv_gwd_front(:, :)
+  !$OMP THREADPRIVATE(dv_gwd_front)
+  REAL, SAVE, ALLOCATABLE :: east_gwstress(:, :)
+  !$OMP THREADPRIVATE(east_gwstress)
+  REAL, SAVE, ALLOCATABLE :: west_gwstress(:, :)
+  !$OMP THREADPRIVATE(west_gwstress)
+  REAL, SAVE, ALLOCATABLE :: d_t_hin(:, :)
+  !$OMP THREADPRIVATE(d_t_hin)
+  ! tendance due a l'oxydation du methane
+  REAL, SAVE, ALLOCATABLE :: d_q_ch4(:, :)
+  !$OMP THREADPRIVATE(d_q_ch4)
 #ifdef ISO
       REAL, SAVE, ALLOCATABLE :: xt_seri(:,:,:)
@@ -172,191 +173,191 @@
 #endif
 
-! tendance du a la conersion Ec -> E thermique
-      REAL, SAVE, ALLOCATABLE :: d_t_ec(:,:)
-      !$OMP THREADPRIVATE(d_t_ec)
-      REAL, SAVE, ALLOCATABLE :: d_ts(:,:), d_tr(:,:,:)
-      !$OMP THREADPRIVATE(d_ts, d_tr)
-
-! diagnostique pour le rayonnement
-      REAL, SAVE, ALLOCATABLE :: topswad_aero(:),  solswad_aero(:)      ! diag
-      !$OMP THREADPRIVATE(topswad_aero,solswad_aero)
-      REAL, SAVE, ALLOCATABLE :: topswai_aero(:),  solswai_aero(:)      ! diag
-      !$OMP THREADPRIVATE(topswai_aero,solswai_aero)
-      REAL, SAVE, ALLOCATABLE :: topswad0_aero(:), solswad0_aero(:)     ! diag
-      !$OMP THREADPRIVATE(topswad0_aero,solswad0_aero)
-      REAL, SAVE, ALLOCATABLE :: topsw_aero(:,:),  solsw_aero(:,:)      ! diag
-      !$OMP THREADPRIVATE(topsw_aero,solsw_aero)
-      REAL, SAVE, ALLOCATABLE :: topsw0_aero(:,:), solsw0_aero(:,:)     ! diag
-      !$OMP THREADPRIVATE(topsw0_aero,solsw0_aero)
-      REAL, SAVE, ALLOCATABLE :: topswcf_aero(:,:),  solswcf_aero(:,:)  ! diag
-      !$OMP THREADPRIVATE(topswcf_aero,solswcf_aero)
-! LW radiation diagnostics CK
-      REAL, SAVE, ALLOCATABLE :: toplwad_aero(:),  sollwad_aero(:)      ! diag
-      !$OMP THREADPRIVATE(toplwad_aero,sollwad_aero)
-      REAL, SAVE, ALLOCATABLE :: toplwai_aero(:),  sollwai_aero(:)      ! diag
-      !$OMP THREADPRIVATE(toplwai_aero,sollwai_aero)
-      REAL, SAVE, ALLOCATABLE :: toplwad0_aero(:), sollwad0_aero(:)     ! diag
-      !$OMP THREADPRIVATE(toplwad0_aero,sollwad0_aero)
-! Special RRTM
-      REAL, SAVE, ALLOCATABLE :: ZLWFT0_i(:,:),  ZSWFT0_i(:,:)      ! diag
-      !$OMP THREADPRIVATE(ZLWFT0_i,ZSWFT0_i)
-      REAL, SAVE, ALLOCATABLE :: ZFLDN0(:,:),  ZFLUP0(:,:)      ! diag
-      !$OMP THREADPRIVATE(ZFLDN0,ZFLUP0)
-      REAL, SAVE, ALLOCATABLE :: ZFSDN0(:,:),  ZFSUP0(:,:)      ! diag
-      !$OMP THREADPRIVATE(ZFSDN0,ZFSUP0)
-!
-      REAL, SAVE, ALLOCATABLE :: stratomask(:,:) 
-      !$OMP THREADPRIVATE(stratomask) 
-      REAL, SAVE, ALLOCATABLE :: tausum_aero(:,:,:) 
-      !$OMP THREADPRIVATE(tausum_aero) 
-      REAL, SAVE, ALLOCATABLE :: drytausum_aero(:,:) 
-      !$OMP THREADPRIVATE(drytausum_aero) 
-      REAL, SAVE, ALLOCATABLE :: tau3d_aero(:,:,:,:) 
-      !$OMP THREADPRIVATE(tau3d_aero) 
-      REAL, SAVE, ALLOCATABLE :: dNovrN(:) 
-      !$OMP THREADPRIVATE(dNovrN) 
-      REAL, SAVE, ALLOCATABLE :: zfice(:,:)
-      !$OMP THREADPRIVATE(zfice)
-      REAL, SAVE, ALLOCATABLE :: od443aer(:) 
-      !$OMP THREADPRIVATE(od443aer) 
-      REAL, SAVE, ALLOCATABLE :: od550aer(:) 
-      !$OMP THREADPRIVATE(od550aer) 
-      REAL, SAVE, ALLOCATABLE :: dryod550aer(:) 
-      !$OMP THREADPRIVATE(dryod550aer) 
-      REAL, SAVE, ALLOCATABLE :: abs550aer(:) 
-      !$OMP THREADPRIVATE(abs550aer) 
-      REAL, SAVE, ALLOCATABLE :: od865aer(:) 
-      !$OMP THREADPRIVATE(od865aer) 
-      REAL, SAVE, ALLOCATABLE :: ec550aer(:,:) 
-      !$OMP THREADPRIVATE(ec550aer) 
-      REAL, SAVE, ALLOCATABLE :: od550lt1aer(:) 
-      !$OMP THREADPRIVATE(od550lt1aer) 
-      REAL, SAVE, ALLOCATABLE :: sconcso4(:) 
-      !$OMP THREADPRIVATE(sconcso4) 
-      REAL, SAVE, ALLOCATABLE :: sconcno3(:) 
-      !$OMP THREADPRIVATE(sconcno3) 
-      REAL, SAVE, ALLOCATABLE :: sconcoa(:) 
-      !$OMP THREADPRIVATE(sconcoa) 
-      REAL, SAVE, ALLOCATABLE :: sconcbc(:) 
-      !$OMP THREADPRIVATE(sconcbc) 
-      REAL, SAVE, ALLOCATABLE :: sconcss(:) 
-      !$OMP THREADPRIVATE(sconcss) 
-      REAL, SAVE, ALLOCATABLE :: sconcdust(:) 
-      !$OMP THREADPRIVATE(sconcdust) 
-      REAL, SAVE, ALLOCATABLE :: concso4(:,:) 
-      !$OMP THREADPRIVATE(concso4) 
-      REAL, SAVE, ALLOCATABLE :: concno3(:,:) 
-      !$OMP THREADPRIVATE(concno3) 
-      REAL, SAVE, ALLOCATABLE :: concoa(:,:) 
-      !$OMP THREADPRIVATE(concoa) 
-      REAL, SAVE, ALLOCATABLE :: concbc(:,:) 
-      !$OMP THREADPRIVATE(concbc) 
-      REAL, SAVE, ALLOCATABLE :: concss(:,:) 
-      !$OMP THREADPRIVATE(concss) 
-      REAL, SAVE, ALLOCATABLE :: concdust(:,:) 
-      !$OMP THREADPRIVATE(concdust) 
-      REAL, SAVE, ALLOCATABLE :: loadso4(:) 
-      !$OMP THREADPRIVATE(loadso4) 
-      REAL, SAVE, ALLOCATABLE :: loadoa(:) 
-      !$OMP THREADPRIVATE(loadoa) 
-      REAL, SAVE, ALLOCATABLE :: loadbc(:) 
-      !$OMP THREADPRIVATE(loadbc) 
-      REAL, SAVE, ALLOCATABLE :: loadss(:) 
-      !$OMP THREADPRIVATE(loadss) 
-      REAL, SAVE, ALLOCATABLE :: loaddust(:) 
-      !$OMP THREADPRIVATE(loaddust) 
-      REAL, SAVE, ALLOCATABLE :: loadno3(:) 
-      !$OMP THREADPRIVATE(loadno3) 
-      REAL, SAVE, ALLOCATABLE :: load_tmp1(:), load_tmp2(:)
-      !$OMP THREADPRIVATE(load_tmp1, load_tmp2) 
-      REAL, SAVE, ALLOCATABLE :: load_tmp3(:), load_tmp4(:)
-      !$OMP THREADPRIVATE(load_tmp3, load_tmp4) 
-      REAL, SAVE, ALLOCATABLE :: load_tmp5(:), load_tmp6(:)
-      !$OMP THREADPRIVATE(load_tmp5, load_tmp6) 
-      REAL, SAVE, ALLOCATABLE :: load_tmp7(:), load_tmp8(:)
-      !$OMP THREADPRIVATE(load_tmp7, load_tmp8) 
-      REAL, SAVE, ALLOCATABLE :: load_tmp9(:), load_tmp10(:)
-      !$OMP THREADPRIVATE(load_tmp9, load_tmp10) 
-
-!IM ajout variables CFMIP2/CMIP5
-      REAL,ALLOCATABLE,SAVE :: topswad_aerop(:), solswad_aerop(:)
-!$OMP THREADPRIVATE(topswad_aerop, solswad_aerop)
-      REAL,ALLOCATABLE,SAVE :: topswai_aerop(:), solswai_aerop(:)
-!$OMP THREADPRIVATE(topswai_aerop, solswai_aerop)
-      REAL,ALLOCATABLE,SAVE :: topswad0_aerop(:), solswad0_aerop(:)
-!$OMP THREADPRIVATE(topswad0_aerop, solswad0_aerop)
-      REAL,ALLOCATABLE,SAVE :: topsw_aerop(:,:), topsw0_aerop(:,:)  
-!$OMP THREADPRIVATE(topsw_aerop, topsw0_aerop)
-      REAL,ALLOCATABLE,SAVE :: solsw_aerop(:,:), solsw0_aerop(:,:)
-!$OMP THREADPRIVATE(solsw_aerop, solsw0_aerop)
-      REAL,ALLOCATABLE,SAVE :: topswcf_aerop(:,:), solswcf_aerop(:,:)
-!$OMP THREADPRIVATE(topswcf_aerop, solswcf_aerop)
-
-! additional LW variables CK
-      REAL,ALLOCATABLE,SAVE :: toplwad_aerop(:), sollwad_aerop(:)
-!$OMP THREADPRIVATE(toplwad_aerop, sollwad_aerop)
-      REAL,ALLOCATABLE,SAVE :: toplwai_aerop(:), sollwai_aerop(:)
-!$OMP THREADPRIVATE(toplwai_aerop, sollwai_aerop)
-      REAL,ALLOCATABLE,SAVE :: toplwad0_aerop(:), sollwad0_aerop(:)
-!$OMP THREADPRIVATE(toplwad0_aerop, sollwad0_aerop)
-
-!AI 08 2023 ajout pour Ecrad
-      REAL,ALLOCATABLE,SAVE :: topswad_aero_s2(:), solswad_aero_s2(:)
-!$OMP THREADPRIVATE(topswad_aero_s2, solswad_aero_s2)
-      REAL,ALLOCATABLE,SAVE :: topswai_aero_s2(:), solswai_aero_s2(:)
-!$OMP THREADPRIVATE(topswai_aero_s2, solswai_aero_s2)
-      REAL,ALLOCATABLE,SAVE :: topswad0_aero_s2(:), solswad0_aero_s2(:)
-!$OMP THREADPRIVATE(topswad0_aero_s2, solswad0_aero_s2)
-      REAL,ALLOCATABLE,SAVE :: topsw_aero_s2(:,:), topsw0_aero_s2(:,:)
-!$OMP THREADPRIVATE(topsw_aero_s2, topsw0_aero_s2)
-      REAL,ALLOCATABLE,SAVE :: solsw_aero_s2(:,:), solsw0_aero_s2(:,:)
-!$OMP THREADPRIVATE(solsw_aero_s2, solsw0_aero_s2)
-      REAL,ALLOCATABLE,SAVE :: topswcf_aero_s2(:,:), solswcf_aero_s2(:,:)
-!$OMP THREADPRIVATE(topswcf_aero_s2, solswcf_aero_s2)
-! additional LW variables CK
-      REAL,ALLOCATABLE,SAVE :: toplwad_aero_s2(:), sollwad_aero_s2(:)
-!$OMP THREADPRIVATE(toplwad_aero_s2, sollwad_aero_s2)
-      REAL,ALLOCATABLE,SAVE :: toplwai_aero_s2(:), sollwai_aero_s2(:)
-!$OMP THREADPRIVATE(toplwai_aero_s2, sollwai_aero_s2)
-      REAL,ALLOCATABLE,SAVE :: toplwad0_aero_s2(:), sollwad0_aero_s2(:)
-!$OMP THREADPRIVATE(toplwad0_aero_s2, sollwad0_aero_s2)
-
-!Ajout de celles n??cessaires au phys_output_write_mod
-      REAL, SAVE, ALLOCATABLE :: tal1(:), pal1(:), pab1(:), pab2(:)
-!$OMP THREADPRIVATE(tal1, pal1, pab1, pab2)
-      REAL, SAVE, ALLOCATABLE :: ptstar(:), pt0(:), slp(:)
-!$OMP THREADPRIVATE(ptstar, pt0, slp)
-      REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: sens, flwp, fiwp 
-!$OMP THREADPRIVATE(sens, flwp, fiwp)
-!!
-!FC 
-      REAL,ALLOCATABLE,SAVE,DIMENSION(:,:) :: zxfluxt, zxfluxq
-!$OMP THREADPRIVATE(zxfluxt, zxfluxq)
-!FC
-!!         Wake variables
-      REAL,ALLOCATABLE,SAVE,DIMENSION(:)            :: alp_wake
-!$OMP THREADPRIVATE(alp_wake)           
-!!jyg!      REAL,ALLOCATABLE,SAVE,DIMENSION(:)            :: wake_h,wake_k
-      REAL,ALLOCATABLE,SAVE,DIMENSION(:)            :: wake_h
-      INTEGER,ALLOCATABLE,SAVE,DIMENSION(:)         :: wake_k
-!$OMP THREADPRIVATE(wake_h,wake_k)                       
-    REAL,ALLOCATABLE,SAVE,DIMENSION(:,:)            :: wake_omg
-!$OMP THREADPRIVATE(wake_omg)                     
-    REAL, SAVE, ALLOCATABLE,DIMENSION(:,:)          :: d_deltat_wk, d_deltaq_wk
-!$OMP THREADPRIVATE(d_deltat_wk, d_deltaq_wk)
-      REAL,ALLOCATABLE,SAVE,DIMENSION(:)            :: d_s_wk, d_s_a_wk, d_dens_wk, d_dens_a_wk
-!$OMP THREADPRIVATE(d_s_wk, d_s_a_wk, d_dens_wk, d_dens_a_wk)
-    REAL, SAVE, ALLOCATABLE,DIMENSION(:,:)          :: d_deltat_wk_gw, d_deltaq_wk_gw
-!$OMP THREADPRIVATE(d_deltat_wk_gw, d_deltaq_wk_gw)
-    REAL, SAVE, ALLOCATABLE,DIMENSION(:,:)          :: d_deltat_vdf, d_deltaq_vdf
-!$OMP THREADPRIVATE(d_deltat_vdf, d_deltaq_vdf)
-!!!      REAL,ALLOCATABLE,SAVE,DIMENSION(:)          :: d_s_vdf, d_dens_vdf
-!!!$OMP THREADPRIVATE(d_s_vdf, d_dens_vdf)
-    REAL, SAVE, ALLOCATABLE,DIMENSION(:,:)          :: d_deltat_the, d_deltaq_the
-!$OMP THREADPRIVATE(d_deltat_the, d_deltaq_the)
-!!!      REAL,ALLOCATABLE,SAVE,DIMENSION(:)          :: d_s_the, d_dens_the
-!!!$OMP THREADPRIVATE(d_s_the, d_dens_the)
-      REAL,ALLOCATABLE,SAVE,DIMENSION(:,:)           :: d_deltat_ajs_cv, d_deltaq_ajs_cv
-!$OMP THREADPRIVATE(d_deltat_ajs_cv, d_deltaq_ajs_cv)
+  ! tendance du a la conersion Ec -> E thermique
+  REAL, SAVE, ALLOCATABLE :: d_t_ec(:, :)
+  !$OMP THREADPRIVATE(d_t_ec)
+  REAL, SAVE, ALLOCATABLE :: d_ts(:, :), d_tr(:, :, :)
+  !$OMP THREADPRIVATE(d_ts, d_tr)
+
+  ! diagnostique pour le rayonnement
+  REAL, SAVE, ALLOCATABLE :: topswad_aero(:), solswad_aero(:)      ! diag
+  !$OMP THREADPRIVATE(topswad_aero,solswad_aero)
+  REAL, SAVE, ALLOCATABLE :: topswai_aero(:), solswai_aero(:)      ! diag
+  !$OMP THREADPRIVATE(topswai_aero,solswai_aero)
+  REAL, SAVE, ALLOCATABLE :: topswad0_aero(:), solswad0_aero(:)     ! diag
+  !$OMP THREADPRIVATE(topswad0_aero,solswad0_aero)
+  REAL, SAVE, ALLOCATABLE :: topsw_aero(:, :), solsw_aero(:, :)      ! diag
+  !$OMP THREADPRIVATE(topsw_aero,solsw_aero)
+  REAL, SAVE, ALLOCATABLE :: topsw0_aero(:, :), solsw0_aero(:, :)     ! diag
+  !$OMP THREADPRIVATE(topsw0_aero,solsw0_aero)
+  REAL, SAVE, ALLOCATABLE :: topswcf_aero(:, :), solswcf_aero(:, :)  ! diag
+  !$OMP THREADPRIVATE(topswcf_aero,solswcf_aero)
+  ! LW radiation diagnostics CK
+  REAL, SAVE, ALLOCATABLE :: toplwad_aero(:), sollwad_aero(:)      ! diag
+  !$OMP THREADPRIVATE(toplwad_aero,sollwad_aero)
+  REAL, SAVE, ALLOCATABLE :: toplwai_aero(:), sollwai_aero(:)      ! diag
+  !$OMP THREADPRIVATE(toplwai_aero,sollwai_aero)
+  REAL, SAVE, ALLOCATABLE :: toplwad0_aero(:), sollwad0_aero(:)     ! diag
+  !$OMP THREADPRIVATE(toplwad0_aero,sollwad0_aero)
+  ! Special RRTM
+  REAL, SAVE, ALLOCATABLE :: ZLWFT0_i(:, :), ZSWFT0_i(:, :)      ! diag
+  !$OMP THREADPRIVATE(ZLWFT0_i,ZSWFT0_i)
+  REAL, SAVE, ALLOCATABLE :: ZFLDN0(:, :), ZFLUP0(:, :)      ! diag
+  !$OMP THREADPRIVATE(ZFLDN0,ZFLUP0)
+  REAL, SAVE, ALLOCATABLE :: ZFSDN0(:, :), ZFSUP0(:, :)      ! diag
+  !$OMP THREADPRIVATE(ZFSDN0,ZFSUP0)
+  !
+  REAL, SAVE, ALLOCATABLE :: stratomask(:, :)
+  !$OMP THREADPRIVATE(stratomask)
+  REAL, SAVE, ALLOCATABLE :: tausum_aero(:, :, :)
+  !$OMP THREADPRIVATE(tausum_aero)
+  REAL, SAVE, ALLOCATABLE :: drytausum_aero(:, :)
+  !$OMP THREADPRIVATE(drytausum_aero)
+  REAL, SAVE, ALLOCATABLE :: tau3d_aero(:, :, :, :)
+  !$OMP THREADPRIVATE(tau3d_aero)
+  REAL, SAVE, ALLOCATABLE :: dNovrN(:)
+  !$OMP THREADPRIVATE(dNovrN)
+  REAL, SAVE, ALLOCATABLE :: zfice(:, :)
+  !$OMP THREADPRIVATE(zfice)
+  REAL, SAVE, ALLOCATABLE :: od443aer(:)
+  !$OMP THREADPRIVATE(od443aer)
+  REAL, SAVE, ALLOCATABLE :: od550aer(:)
+  !$OMP THREADPRIVATE(od550aer)
+  REAL, SAVE, ALLOCATABLE :: dryod550aer(:)
+  !$OMP THREADPRIVATE(dryod550aer)
+  REAL, SAVE, ALLOCATABLE :: abs550aer(:)
+  !$OMP THREADPRIVATE(abs550aer)
+  REAL, SAVE, ALLOCATABLE :: od865aer(:)
+  !$OMP THREADPRIVATE(od865aer)
+  REAL, SAVE, ALLOCATABLE :: ec550aer(:, :)
+  !$OMP THREADPRIVATE(ec550aer)
+  REAL, SAVE, ALLOCATABLE :: od550lt1aer(:)
+  !$OMP THREADPRIVATE(od550lt1aer)
+  REAL, SAVE, ALLOCATABLE :: sconcso4(:)
+  !$OMP THREADPRIVATE(sconcso4)
+  REAL, SAVE, ALLOCATABLE :: sconcno3(:)
+  !$OMP THREADPRIVATE(sconcno3)
+  REAL, SAVE, ALLOCATABLE :: sconcoa(:)
+  !$OMP THREADPRIVATE(sconcoa)
+  REAL, SAVE, ALLOCATABLE :: sconcbc(:)
+  !$OMP THREADPRIVATE(sconcbc)
+  REAL, SAVE, ALLOCATABLE :: sconcss(:)
+  !$OMP THREADPRIVATE(sconcss)
+  REAL, SAVE, ALLOCATABLE :: sconcdust(:)
+  !$OMP THREADPRIVATE(sconcdust)
+  REAL, SAVE, ALLOCATABLE :: concso4(:, :)
+  !$OMP THREADPRIVATE(concso4)
+  REAL, SAVE, ALLOCATABLE :: concno3(:, :)
+  !$OMP THREADPRIVATE(concno3)
+  REAL, SAVE, ALLOCATABLE :: concoa(:, :)
+  !$OMP THREADPRIVATE(concoa)
+  REAL, SAVE, ALLOCATABLE :: concbc(:, :)
+  !$OMP THREADPRIVATE(concbc)
+  REAL, SAVE, ALLOCATABLE :: concss(:, :)
+  !$OMP THREADPRIVATE(concss)
+  REAL, SAVE, ALLOCATABLE :: concdust(:, :)
+  !$OMP THREADPRIVATE(concdust)
+  REAL, SAVE, ALLOCATABLE :: loadso4(:)
+  !$OMP THREADPRIVATE(loadso4)
+  REAL, SAVE, ALLOCATABLE :: loadoa(:)
+  !$OMP THREADPRIVATE(loadoa)
+  REAL, SAVE, ALLOCATABLE :: loadbc(:)
+  !$OMP THREADPRIVATE(loadbc)
+  REAL, SAVE, ALLOCATABLE :: loadss(:)
+  !$OMP THREADPRIVATE(loadss)
+  REAL, SAVE, ALLOCATABLE :: loaddust(:)
+  !$OMP THREADPRIVATE(loaddust)
+  REAL, SAVE, ALLOCATABLE :: loadno3(:)
+  !$OMP THREADPRIVATE(loadno3)
+  REAL, SAVE, ALLOCATABLE :: load_tmp1(:), load_tmp2(:)
+  !$OMP THREADPRIVATE(load_tmp1, load_tmp2)
+  REAL, SAVE, ALLOCATABLE :: load_tmp3(:), load_tmp4(:)
+  !$OMP THREADPRIVATE(load_tmp3, load_tmp4)
+  REAL, SAVE, ALLOCATABLE :: load_tmp5(:), load_tmp6(:)
+  !$OMP THREADPRIVATE(load_tmp5, load_tmp6)
+  REAL, SAVE, ALLOCATABLE :: load_tmp7(:), load_tmp8(:)
+  !$OMP THREADPRIVATE(load_tmp7, load_tmp8)
+  REAL, SAVE, ALLOCATABLE :: load_tmp9(:), load_tmp10(:)
+  !$OMP THREADPRIVATE(load_tmp9, load_tmp10)
+
+  !IM ajout variables CFMIP2/CMIP5
+  REAL, ALLOCATABLE, SAVE :: topswad_aerop(:), solswad_aerop(:)
+  !$OMP THREADPRIVATE(topswad_aerop, solswad_aerop)
+  REAL, ALLOCATABLE, SAVE :: topswai_aerop(:), solswai_aerop(:)
+  !$OMP THREADPRIVATE(topswai_aerop, solswai_aerop)
+  REAL, ALLOCATABLE, SAVE :: topswad0_aerop(:), solswad0_aerop(:)
+  !$OMP THREADPRIVATE(topswad0_aerop, solswad0_aerop)
+  REAL, ALLOCATABLE, SAVE :: topsw_aerop(:, :), topsw0_aerop(:, :)
+  !$OMP THREADPRIVATE(topsw_aerop, topsw0_aerop)
+  REAL, ALLOCATABLE, SAVE :: solsw_aerop(:, :), solsw0_aerop(:, :)
+  !$OMP THREADPRIVATE(solsw_aerop, solsw0_aerop)
+  REAL, ALLOCATABLE, SAVE :: topswcf_aerop(:, :), solswcf_aerop(:, :)
+  !$OMP THREADPRIVATE(topswcf_aerop, solswcf_aerop)
+
+  ! additional LW variables CK
+  REAL, ALLOCATABLE, SAVE :: toplwad_aerop(:), sollwad_aerop(:)
+  !$OMP THREADPRIVATE(toplwad_aerop, sollwad_aerop)
+  REAL, ALLOCATABLE, SAVE :: toplwai_aerop(:), sollwai_aerop(:)
+  !$OMP THREADPRIVATE(toplwai_aerop, sollwai_aerop)
+  REAL, ALLOCATABLE, SAVE :: toplwad0_aerop(:), sollwad0_aerop(:)
+  !$OMP THREADPRIVATE(toplwad0_aerop, sollwad0_aerop)
+
+  !AI 08 2023 ajout pour Ecrad
+  REAL, ALLOCATABLE, SAVE :: topswad_aero_s2(:), solswad_aero_s2(:)
+  !$OMP THREADPRIVATE(topswad_aero_s2, solswad_aero_s2)
+  REAL, ALLOCATABLE, SAVE :: topswai_aero_s2(:), solswai_aero_s2(:)
+  !$OMP THREADPRIVATE(topswai_aero_s2, solswai_aero_s2)
+  REAL, ALLOCATABLE, SAVE :: topswad0_aero_s2(:), solswad0_aero_s2(:)
+  !$OMP THREADPRIVATE(topswad0_aero_s2, solswad0_aero_s2)
+  REAL, ALLOCATABLE, SAVE :: topsw_aero_s2(:, :), topsw0_aero_s2(:, :)
+  !$OMP THREADPRIVATE(topsw_aero_s2, topsw0_aero_s2)
+  REAL, ALLOCATABLE, SAVE :: solsw_aero_s2(:, :), solsw0_aero_s2(:, :)
+  !$OMP THREADPRIVATE(solsw_aero_s2, solsw0_aero_s2)
+  REAL, ALLOCATABLE, SAVE :: topswcf_aero_s2(:, :), solswcf_aero_s2(:, :)
+  !$OMP THREADPRIVATE(topswcf_aero_s2, solswcf_aero_s2)
+  ! additional LW variables CK
+  REAL, ALLOCATABLE, SAVE :: toplwad_aero_s2(:), sollwad_aero_s2(:)
+  !$OMP THREADPRIVATE(toplwad_aero_s2, sollwad_aero_s2)
+  REAL, ALLOCATABLE, SAVE :: toplwai_aero_s2(:), sollwai_aero_s2(:)
+  !$OMP THREADPRIVATE(toplwai_aero_s2, sollwai_aero_s2)
+  REAL, ALLOCATABLE, SAVE :: toplwad0_aero_s2(:), sollwad0_aero_s2(:)
+  !$OMP THREADPRIVATE(toplwad0_aero_s2, sollwad0_aero_s2)
+
+  !Ajout de celles n??cessaires au phys_output_write_mod
+  REAL, SAVE, ALLOCATABLE :: tal1(:), pal1(:), pab1(:), pab2(:)
+  !$OMP THREADPRIVATE(tal1, pal1, pab1, pab2)
+  REAL, SAVE, ALLOCATABLE :: ptstar(:), pt0(:), slp(:)
+  !$OMP THREADPRIVATE(ptstar, pt0, slp)
+  REAL, ALLOCATABLE, SAVE, DIMENSION(:) :: sens, flwp, fiwp
+  !$OMP THREADPRIVATE(sens, flwp, fiwp)
+  !!
+  !FC
+  REAL, ALLOCATABLE, SAVE, DIMENSION(:, :) :: zxfluxt, zxfluxq
+  !$OMP THREADPRIVATE(zxfluxt, zxfluxq)
+  !FC
+  !!         Wake variables
+  REAL, ALLOCATABLE, SAVE, DIMENSION(:) :: alp_wake
+  !$OMP THREADPRIVATE(alp_wake)
+  !!jyg!      REAL,ALLOCATABLE,SAVE,DIMENSION(:)            :: wake_h,wake_k
+  REAL, ALLOCATABLE, SAVE, DIMENSION(:) :: wake_h
+  INTEGER, ALLOCATABLE, SAVE, DIMENSION(:) :: wake_k
+  !$OMP THREADPRIVATE(wake_h,wake_k)
+  REAL, ALLOCATABLE, SAVE, DIMENSION(:, :) :: wake_omg
+  !$OMP THREADPRIVATE(wake_omg)
+  REAL, SAVE, ALLOCATABLE, DIMENSION(:, :) :: d_deltat_wk, d_deltaq_wk
+  !$OMP THREADPRIVATE(d_deltat_wk, d_deltaq_wk)
+  REAL, ALLOCATABLE, SAVE, DIMENSION(:) :: d_s_wk, d_s_a_wk, d_dens_wk, d_dens_a_wk
+  !$OMP THREADPRIVATE(d_s_wk, d_s_a_wk, d_dens_wk, d_dens_a_wk)
+  REAL, SAVE, ALLOCATABLE, DIMENSION(:, :) :: d_deltat_wk_gw, d_deltaq_wk_gw
+  !$OMP THREADPRIVATE(d_deltat_wk_gw, d_deltaq_wk_gw)
+  REAL, SAVE, ALLOCATABLE, DIMENSION(:, :) :: d_deltat_vdf, d_deltaq_vdf
+  !$OMP THREADPRIVATE(d_deltat_vdf, d_deltaq_vdf)
+  !!!      REAL,ALLOCATABLE,SAVE,DIMENSION(:)          :: d_s_vdf, d_dens_vdf
+  !!!$OMP THREADPRIVATE(d_s_vdf, d_dens_vdf)
+  REAL, SAVE, ALLOCATABLE, DIMENSION(:, :) :: d_deltat_the, d_deltaq_the
+  !$OMP THREADPRIVATE(d_deltat_the, d_deltaq_the)
+  !!!      REAL,ALLOCATABLE,SAVE,DIMENSION(:)          :: d_s_the, d_dens_the
+  !!!$OMP THREADPRIVATE(d_s_the, d_dens_the)
+  REAL, ALLOCATABLE, SAVE, DIMENSION(:, :) :: d_deltat_ajs_cv, d_deltaq_ajs_cv
+  !$OMP THREADPRIVATE(d_deltat_ajs_cv, d_deltaq_ajs_cv)
 #ifdef ISO
     REAL, SAVE, ALLOCATABLE,DIMENSION(:,:,:)          :: d_deltaxt_wk
